require 'qntf/storage/json'
require 'spec_helper'

describe 'Qntf::Storage::Json', :fakefs do
  subject { Qntf::Storage::Json::Dataset }

  describe '.all' do
    before { File.open('test.json', 'w') { |f| f.puts '{fields: [], data: {}}' }}
    before { File.open('test2.json', 'w') { |f| f.puts '{fields: [], data: {}}' }}

    it 'lists all datasets in the given directory' do
      expect(subject.all).to eq ['test', 'test2']
    end
  end

  describe '.new' do
    it 'creates a new boilerplate dataset' do

      dataset = subject.new('test3')
      expect(subject.all).to include 'test3'
    end
  end
end

describe 'Qntf::Storage::Json.new', :fakefs do
  subject { Qntf::Storage::Json::Dataset.new('test4') }

  describe '.fields and .add_field' do
    it 'has no fields by default' do
      expect(subject.fields).to eq []
    end

    it 'adds fields correctly' do
      subject.add_field('hodor')
      expect(subject.fields).to eq ['hodor']
    end
  end
end
